Bug 459961 - [enh] use local caching nameserver for split DNS, among other things
[enh] use local caching nameserver for split DNS, among other things
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: NetworkManager (Show other bugs)
12
All Linux
medium Severity low
: ---
: ---
Assigned To: Dan Williams
Fedora Extras Quality Assurance
: Triaged
: 632116 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-08-25 05:40 EDT by Andrew Bartlett
Modified: 2010-12-05 02:08 EST (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-12-05 02:08:36 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
/etc/NetworkManager/dispatcher.d/99-dnsmasq-juggling (476 bytes, text/plain)
2009-01-19 13:00 EST, Matěj Cepl
no flags Details

  None (edit)
Description Andrew Bartlett 2008-08-25 05:40:01 EDT
Description of problem:
When connected to the company VPN and a home network, it is not possible to resolve names in both. 

Version-Release number of selected component (if applicable):
NetworkManager-0.7.0-0.9.4.svn3675.fc9.x86_64

How reproducible:
Every time

Steps to Reproduce:
1.  Connect to a VPN (vpnc for the sake of argument)
2.  Attempt to resolve a local name, not visible in the global internet
3.  
  
Actual results:
Fail to resolve local names, as company VPN is queried

Expected results:
Ability to look up both company and local names

Additional info:

I run local libvirt networks, with VMs serving DNS, as well as a local (on my laptop) DNS zone for my Samba development.  Currently I must manually replace resolv.conf with an entry to point to 127.0.0.1 and then manually set the forwarders.

It would be great if I could define the libvirt interface as pointing to the VM servers (AD domains I test against in this case), and to forward particular domains to the VPN and others to default route etc.

Reverse DNS would naturally also need to be included, but this is easily worked on the basis of the routing table.  Getting this right could make the forward and reverse names that dnsmasq generates (for example on the 'share this interface' configuration) usable.
Comment 1 Dan Williams 2008-08-25 12:59:17 EDT
FYI, this cannot be done with the glibc resolver.  You'd need lwresd running, or a local caching nameserver that's able to do split DNS.  NM used to launch bind as a local caching nameserver, but tons and tons of people started complaining about "why do I have to run bind on me desktop it's insecure and takes up memory wah wah" and such.  Thus the functionality was removed.

It could be accomplished again via dispatcher scripts, or a D-Bus enabled service (like named itself) listening to NetworkManager interface messages that would grab the IP4Config exported by NM for each connection and send that to the local caching nameserver, then rewrite /etc/resolv.conf to point to 127.0.0.1 automatically.
Comment 2 Andrew Bartlett 2008-08-25 18:34:32 EDT
I would be quite happy with a local caching DNS server running.  It seems from the manual that lwresd would be more secure than the current setup (getting randomised source ports, assuming the bind9 library does that), but won't help with the zone splitting.
Comment 3 Matěj Cepl 2009-01-19 10:37:16 EST
(In reply to comment #1)
> FYI, this cannot be done with the glibc resolver.  You'd need lwresd running,
> or a local caching nameserver that's able to do split DNS.  NM used to launch
> bind as a local caching nameserver, but tons and tons of people started
> complaining about "why do I have to run bind on me desktop it's insecure and
> takes up memory wah wah" and such.  Thus the functionality was removed.

Cannot we get at least optional -- i.e., if I have dnsmasq (or lwresd if that works, I don't know anything about that yet) installed, then I have a checkbox "Use DNS in this network only for the machines on this network" (similar to "Use this connection only for resources on its network"; my checkbox could be somehow subcheckbox for the latter or something).

> It could be accomplished again via dispatcher scripts, or a D-Bus enabled
> service (like named itself) listening to NetworkManager interface messages that

IIRC, named doesn't work with DBUS anymore.

> would grab the IP4Config exported by NM for each connection and send that to
> the local caching nameserver, then rewrite /etc/resolv.conf to point to
> 127.0.0.1 automatically.

Could we get an example of this NMDispatcher script?
Comment 4 Matěj Cepl 2009-01-19 13:00:28 EST
Created attachment 329372 [details]
/etc/NetworkManager/dispatcher.d/99-dnsmasq-juggling

Attached script could be an example of what might work -- of course, it needs to be generalized and made working with some kind of configuration file. (This is mostly for other people stumbling on this bug as an information what could be done).
Comment 5 Bug Zapper 2009-06-09 22:32:31 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 6 Andrew Bartlett 2009-06-09 22:43:15 EDT
I understand this is still in Fedora 10, yet to check 11.
Comment 7 Bug Zapper 2009-11-16 03:11:44 EST
This bug appears to have been reported against 'rawhide' during the Fedora 12 development cycle.
Changing version to '12'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 8 Dan Williams 2010-09-09 11:34:26 EDT
*** Bug 632116 has been marked as a duplicate of this bug. ***
Comment 9 Bug Zapper 2010-11-04 07:48:15 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 10 Bug Zapper 2010-12-05 02:08:36 EST
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.